summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: 70087cd)
raw | patch | inline | side by side (parent: 70087cd)
author | Junio C Hamano <gitster@pobox.com> | |
Sat, 15 Dec 2007 06:02:57 +0000 (22:02 -0800) | ||
committer | Junio C Hamano <gitster@pobox.com> | |
Sat, 15 Dec 2007 06:04:43 +0000 (22:04 -0800) |
Signed-off-by: Junio C Hamano <gitster@pobox.com>
.gitignore | patch | blob | history | |
Documentation/git-help.txt | patch | blob | history | |
Makefile | patch | blob | history | |
git-browse--help.sh | [new file with mode: 0755] | patch | blob |
git-browse-help.sh | [deleted file] | patch | blob | history |
help.c | patch | blob | history |
diff --git a/.gitignore b/.gitignore
index 5eaba4199511d12a3a1628965aeb5425453c72f9..aef01c5a2b62c7d2c15b7890925530c132425119 100644 (file)
--- a/.gitignore
+++ b/.gitignore
git-bisect
git-blame
git-branch
-git-browse-help
+git-browse--help
git-bundle
git-cat-file
git-check-attr
index 31ec403a705456b0fcc41eb7196484e0919eccae..8cd69e7129f431185a1d78953cde5d955675372d 100644 (file)
+
The web browser can be specified using the configuration variable
'help.browser', or 'web.browser' if the former is not set. If none of
-these config variables is set, the 'git-browse-help' script (called by
-'git-help') will pick a suitable default.
+these config variables is set, the 'git-browse--help' helper script
+(called by 'git-help') will pick a suitable default.
+
You can explicitly provide a full path to your prefered browser by
setting the configuration variable 'browser.<tool>.path'. For example,
you can configure the absolute path to firefox by setting
-'browser.firefox.path'. Otherwise, 'git-browse-help' assumes the tool
+'browser.firefox.path'. Otherwise, 'git-browse--help' assumes the tool
is available in PATH.
+
Note that the script tries, as much as possible, to display the HTML
diff --git a/Makefile b/Makefile
index 16de2f3e252ad2b3324c0c439ad6e771e4ca358c..43d6197495f6cde1be725388902e557884b81917 100644 (file)
--- a/Makefile
+++ b/Makefile
git-lost-found.sh git-quiltimport.sh git-submodule.sh \
git-filter-branch.sh \
git-stash.sh \
- git-browse-help.sh
+ git-browse--help.sh
SCRIPT_PERL = \
git-add--interactive.perl \
case "$$v" in \
git-merge-octopus | git-merge-ours | git-merge-recursive | \
git-merge-resolve | git-merge-stupid | git-merge-subtree | \
- git-add--interactive | git-fsck-objects | git-init-db | \
- git-rebase--interactive | \
- git-repo-config | git-fetch--tool ) continue ;; \
+ git-fsck-objects | git-init-db | git-repo-config | \
+ git-?*--?* ) continue ;; \
esac ; \
test -f "Documentation/$$v.txt" || \
echo "no doc: $$v"; \
diff --git a/git-browse--help.sh b/git-browse--help.sh
--- /dev/null
+++ b/git-browse--help.sh
@@ -0,0 +1,149 @@
+#!/bin/sh
+#
+# This program launch a web browser on the html page
+# describing a git command.
+#
+# Copyright (c) 2007 Christian Couder
+# Copyright (c) 2006 Theodore Y. Ts'o
+#
+# This file is heavily stolen from git-mergetool.sh, by
+# Theodore Y. Ts'o (thanks) that is:
+#
+# Copyright (c) 2006 Theodore Y. Ts'o
+#
+# This file is licensed under the GPL v2, or a later version
+# at the discretion of Junio C Hamano or any other official
+# git maintainer.
+#
+
+USAGE='[--browser=browser|--tool=browser] [cmd to display] ...'
+
+# This must be capable of running outside of git directory, so
+# the vanilla git-sh-setup should not be used.
+NONGIT_OK=Yes
+. git-sh-setup
+
+# Install data.
+html_dir="@@HTMLDIR@@"
+
+test -f "$html_dir/git.html" || die "No documentation directory found."
+
+valid_tool() {
+ case "$1" in
+ firefox | iceweasel | konqueror | w3m | links | lynx | dillo)
+ ;; # happy
+ *)
+ return 1
+ ;;
+ esac
+}
+
+init_browser_path() {
+ browser_path=`git config browser.$1.path`
+ test -z "$browser_path" && browser_path=$1
+}
+
+while test $# != 0
+do
+ case "$1" in
+ -b|--browser*|-t|--tool*)
+ case "$#,$1" in
+ *,*=*)
+ browser=`expr "z$1" : 'z-[^=]*=\(.*\)'`
+ ;;
+ 1,*)
+ usage ;;
+ *)
+ browser="$2"
+ shift ;;
+ esac
+ ;;
+ --)
+ break
+ ;;
+ -*)
+ usage
+ ;;
+ *)
+ break
+ ;;
+ esac
+ shift
+done
+
+if test -z "$browser"
+then
+ for opt in "help.browser" "web.browser"
+ do
+ browser="`git config $opt`"
+ test -z "$browser" || break
+ done
+ if test -n "$browser" && ! valid_tool "$browser"; then
+ echo >&2 "git config option $opt set to unknown browser: $browser"
+ echo >&2 "Resetting to default..."
+ unset browser
+ fi
+fi
+
+if test -z "$browser" ; then
+ if test -n "$DISPLAY"; then
+ browser_candidates="firefox iceweasel konqueror w3m links lynx dillo"
+ if test "$KDE_FULL_SESSION" = "true"; then
+ browser_candidates="konqueror $browser_candidates"
+ fi
+ else
+ browser_candidates="w3m links lynx"
+ fi
+
+ for i in $browser_candidates; do
+ init_browser_path $i
+ if type "$browser_path" > /dev/null 2>&1; then
+ browser=$i
+ break
+ fi
+ done
+ test -z "$browser" && die "No known browser available."
+else
+ valid_tool "$browser" || die "Unknown browser '$browser'."
+
+ init_browser_path "$browser"
+
+ if ! type "$browser_path" > /dev/null 2>&1; then
+ die "The browser $browser is not available as '$browser_path'."
+ fi
+fi
+
+pages=$(for p in "$@"; do echo "$html_dir/$p.html" ; done)
+test -z "$pages" && pages="$html_dir/git.html"
+
+case "$browser" in
+ firefox|iceweasel)
+ # Check version because firefox < 2.0 does not support "-new-tab".
+ vers=$(expr "$($browser_path -version)" : '.* \([0-9][0-9]*\)\..*')
+ NEWTAB='-new-tab'
+ test "$vers" -lt 2 && NEWTAB=''
+ nohup "$browser_path" $NEWTAB $pages &
+ ;;
+ konqueror)
+ case "$(basename "$browser_path")" in
+ konqueror)
+ # It's simpler to use kfmclient to open a new tab in konqueror.
+ browser_path="$(echo "$browser_path" | sed -e 's/konqueror$/kfmclient/')"
+ type "$browser_path" > /dev/null 2>&1 || die "No '$browser_path' found."
+ eval "$browser_path" newTab $pages
+ ;;
+ kfmclient)
+ eval "$browser_path" newTab $pages
+ ;;
+ *)
+ nohup "$browser_path" $pages &
+ ;;
+ esac
+ ;;
+ w3m|links|lynx)
+ eval "$browser_path" $pages
+ ;;
+ dillo)
+ nohup "$browser_path" $pages &
+ ;;
+esac
diff --git a/git-browse-help.sh b/git-browse-help.sh
--- a/git-browse-help.sh
+++ /dev/null
@@ -1,149 +0,0 @@
-#!/bin/sh
-#
-# This program launch a web browser on the html page
-# describing a git command.
-#
-# Copyright (c) 2007 Christian Couder
-# Copyright (c) 2006 Theodore Y. Ts'o
-#
-# This file is heavily stolen from git-mergetool.sh, by
-# Theodore Y. Ts'o (thanks) that is:
-#
-# Copyright (c) 2006 Theodore Y. Ts'o
-#
-# This file is licensed under the GPL v2, or a later version
-# at the discretion of Junio C Hamano or any other official
-# git maintainer.
-#
-
-USAGE='[--browser=browser|--tool=browser] [cmd to display] ...'
-
-# This must be capable of running outside of git directory, so
-# the vanilla git-sh-setup should not be used.
-NONGIT_OK=Yes
-. git-sh-setup
-
-# Install data.
-html_dir="@@HTMLDIR@@"
-
-test -f "$html_dir/git.html" || die "No documentation directory found."
-
-valid_tool() {
- case "$1" in
- firefox | iceweasel | konqueror | w3m | links | lynx | dillo)
- ;; # happy
- *)
- return 1
- ;;
- esac
-}
-
-init_browser_path() {
- browser_path=`git config browser.$1.path`
- test -z "$browser_path" && browser_path=$1
-}
-
-while test $# != 0
-do
- case "$1" in
- -b|--browser*|-t|--tool*)
- case "$#,$1" in
- *,*=*)
- browser=`expr "z$1" : 'z-[^=]*=\(.*\)'`
- ;;
- 1,*)
- usage ;;
- *)
- browser="$2"
- shift ;;
- esac
- ;;
- --)
- break
- ;;
- -*)
- usage
- ;;
- *)
- break
- ;;
- esac
- shift
-done
-
-if test -z "$browser"
-then
- for opt in "help.browser" "web.browser"
- do
- browser="`git config $opt`"
- test -z "$browser" || break
- done
- if test -n "$browser" && ! valid_tool "$browser"; then
- echo >&2 "git config option $opt set to unknown browser: $browser"
- echo >&2 "Resetting to default..."
- unset browser
- fi
-fi
-
-if test -z "$browser" ; then
- if test -n "$DISPLAY"; then
- browser_candidates="firefox iceweasel konqueror w3m links lynx dillo"
- if test "$KDE_FULL_SESSION" = "true"; then
- browser_candidates="konqueror $browser_candidates"
- fi
- else
- browser_candidates="w3m links lynx"
- fi
-
- for i in $browser_candidates; do
- init_browser_path $i
- if type "$browser_path" > /dev/null 2>&1; then
- browser=$i
- break
- fi
- done
- test -z "$browser" && die "No known browser available."
-else
- valid_tool "$browser" || die "Unknown browser '$browser'."
-
- init_browser_path "$browser"
-
- if ! type "$browser_path" > /dev/null 2>&1; then
- die "The browser $browser is not available as '$browser_path'."
- fi
-fi
-
-pages=$(for p in "$@"; do echo "$html_dir/$p.html" ; done)
-test -z "$pages" && pages="$html_dir/git.html"
-
-case "$browser" in
- firefox|iceweasel)
- # Check version because firefox < 2.0 does not support "-new-tab".
- vers=$(expr "$($browser_path -version)" : '.* \([0-9][0-9]*\)\..*')
- NEWTAB='-new-tab'
- test "$vers" -lt 2 && NEWTAB=''
- nohup "$browser_path" $NEWTAB $pages &
- ;;
- konqueror)
- case "$(basename "$browser_path")" in
- konqueror)
- # It's simpler to use kfmclient to open a new tab in konqueror.
- browser_path="$(echo "$browser_path" | sed -e 's/konqueror$/kfmclient/')"
- type "$browser_path" > /dev/null 2>&1 || die "No '$browser_path' found."
- eval "$browser_path" newTab $pages
- ;;
- kfmclient)
- eval "$browser_path" newTab $pages
- ;;
- *)
- nohup "$browser_path" $pages &
- ;;
- esac
- ;;
- w3m|links|lynx)
- eval "$browser_path" $pages
- ;;
- dillo)
- nohup "$browser_path" $pages &
- ;;
-esac
index 551b5b93b37f49e53746cb628416ab34d1dd9bd5..f9ce6db34f43874442223468dbc536a7369ae1c5 100644 (file)
--- a/help.c
+++ b/help.c
static void show_html_page(const char *git_cmd)
{
const char *page = cmd_to_page(git_cmd);
- execl_git_cmd("browse-help", page, NULL);
+ execl_git_cmd("browse--help", page, NULL);
}
void help_unknown_cmd(const char *cmd)